<html>

<head>
  <title>Small VanillaJS Vue.js App</title>
  <style>
    [v-cloak] {
      display: none
    }
  </style>
</head>

<body>
  <!-- 1. add an element to host your vue.js app here -->
  <!-- 2. add an address from { id, road, complement, zipCode, city, country, state -->
  <!-- 3. add another address to -->
  <!-- 4. add conditional fields -->
  <!-- 5. add a form to edit the address -->
  <!-- 6. allow dynamic adding / update / delete -->
  <!-- 7. maybe refactor somewhere ?! -->
  <div id="app">
    <m-c-address v-cloak
      :address="from"
      label="From"
    ></m-c-address>
    <m-c-address v-cloak :address="to" label="To"></m-c-address>
    <mc-address-form
      :address="from"
    ></mc-address-form>
  </div>

  <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
  <script type="text/javascript">
    var Address = {
      template: `<div>
      <strong>Address {{label}}</strong><br/>
      Road : {{ address.road }}<br/>
      Zip Code : {{ address.zipCode }}<br/>
      City : {{ address.city }}<br/>
      <span v-if="address.complement">Complement: {{ address.complement }}<br/></span>
      <span v-if="address.country">Country: {{ address.country }}<br/></span>
      <span v-if="address.state">State: {{ address.state }}<br/></span>
    </div>`,
      props: ['address', 'label']
    };

    var AddressForm = Vue.component('mc-address-form', {
      template: `<form>
      Road : <input v-model="address.road" type="text" /><br/>
      Zip Code : <input v-model="address.zipCode" type="number" /><br/>
      City : <input v-model="address.city" type="text" /><br/>
      Complement : <input v-model="address.complement" type="text" /><br/>
      Country : <input v-model="address.country" type="text" /><br/>
      State : <input v-model="address.state" type="text" /><br/>
    </form>`,
      props: ['address']
    });

    var app = new Vue({
      el: '#app',
      data: {
        from: {
          road: '52 rue Jacques Babinet',
          zipCode: '31000',
          city: 'Toulouse',
          complement: 'Makina Corpus',
          country: 'Occitanie'
        }, to: {
          road: 'place du Capitole',
          zipCode: '31000',
          city: 'Toulouse',
          state: 'France'
        }
      },
      components: {
        'm-c-address': Address,
      }
    })
  </script>
</body>

</html>
